{       GranPrimo Component Library                     }
{       Debug and control application via web           }
{                                                       }
{       Copyright (c) 2001-2002 Antonio Alczar Ruiz    }
{*******************************************************}

unit granprimointraweb;

//{$D-}{$L-} {$Y-}
interface

uses
     Windows,sysutils,classes,graphics,spyobjects,IWHTMLTag,
     IWControl,IWExtCtrls ,IWTypes, iwgrids,IWCompButton, iwcomptext,
     iwcomplistbox,iwtreeview;

procedure Register;

type

  TIWGranPrimo = class(TIWDynamicImage)
  protected
    fspy:Tprimo;
    procedure Dispatcherclick(ASender: TObject;const x,y:integer);

  public
    constructor Create(AOwner: TComponent); override;
    function RenderHTML: TIWHTMLTag; override;

  published
    property spy:Tprimo read fspy write fspy;
  end;

  TIWPrimoProperties = class (TIWGrid)
  private
    fspy:Tprimo;
    procedure primoRenderCell(ACell: TIWGridCell;
                const ARow, AColumn: Integer);
  public
    constructor Create(AOwner: TComponent); override;
    procedure getPropiedades;
    procedure AceptarClick;
    function RenderHTML: TIWHTMLTag; override;

  published
    property spy:Tprimo read fspy write fspy;
  end;

  TIWPrimoTreeObject= class (TIWTreeView)
  private
    fPrimoProperties:TIWPrimoProperties;
    fspy:Tprimo;
    procedure  ScanComponents (  aComponent: Tobject; it:TIWTreeViewItems);
    procedure PrimoTreeObjectClick(Sender: TObject);

  public
    constructor Create(AOwner: TComponent); override;
    function RenderHTML: TIWHTMLTag; override;
  published
    property PrimoProperties:TIWPrimoProperties
        read fPrimoProperties write fPrimoProperties;
    property spy:Tprimo read fspy write fspy;
  end;


implementation
uses math,registry,IWServerControllerBase,IWCompEdit;

procedure TIWGranPrimo.Dispatcherclick
        (ASender: TObject;const x,y:integer);
begin
   if spy<>nil then
        spy.ClickEventRel(x,y,Width,Height);
end;

function TIWGranPrimo.RenderHTML: TIWHTMLTag;
var
  LPathname: string;
begin
  if spy<>nil then
  begin
     spy.GetImageScreen(fPicture.Bitmap,width,Height);
  end;
  if not  assigned(onclick) then
        onmousedown:=Dispatcherclick;
  LPathname := TIWServerControllerBase.NewCacheFile('jpg');
  if FPicture.Graphic <> nil then begin
    if not FPicture.Graphic.Empty then begin
      ToJPegFile(FPicture.Graphic, LPathname);
      Result := ImageHTML(WebApplication.URLBase + '/cache/' + ExtractFilename(LPathname));
    end;
  end;
end;


constructor TIWGranPrimo.Create(AOwner: TComponent);
begin
  inherited;
  fspy:=nil;
end;


constructor TIWPrimoProperties.Create(AOwner: TComponent);
begin
   inherited create (aowner);
   fspy:=nil;
end;


procedure TIWPrimoProperties.getPropiedades;
var
  i: Integer;
  LNames: TStringList;
  na,valor:string;
  var lista_:Tstringlist;
begin
  if spy=nil then exit;
  lista_:=Tstringlist.create;
  LNames := TStringList.Create;
  spy.GetListasInfo(lnames);
  rowcount:=lnames.count+1;
  ColumnCount:=3;
        with Cell[0, 0] do begin
          Text := 'Name';
          Width := '200';
        end;
        with Cell[0, 1] do begin
          Text := 'Old Value';
        end;
        with Cell[0, 2] do begin
          Text := 'Value';
          Width := '60';
        end;
          for i := 1 to RowCount- 1  do begin
          na:= Lnames[i-1];
          Cell[i, 0].Text := na;
          lista_.clear;
          valor:=spy.GetPropiedadesObject (na, lista_);
          with Cell[i,1 ] do begin
            text:=valor;
            Alignment := taCenter;
          end;
          with Cell[i, 2] do begin
            Alignment := taRightJustify;
            if lista_.Count>0 then
            begin
             Control := TiwComboBox.Create(owner);
             with TiwComboBox(Control) do begin
              items.AddStrings(lista_);
              itemindex:=items.IndexOf(valor);
              Width := 75;
             end;
            end else
            begin
             Control := TIWEdit.Create(owner);
             with TIWEdit(Control) do begin
              Text := valor;//lvalues[i-1];
              Width := 75;
             end;
            end;
          end;
        end;
   FreeAndNil(LNames);
   lista_.free;
end;


procedure register;
Begin
 registerComponents ('miPrimo',
 [TIWGranPrimo,TIWprimoProperties,TIWPrimoTreeObject,Tprimo]);
end;

procedure TIWprimoProperties.AceptarClick;
var
  LNames: TStringList;
  i:integer;
  texto:string;
begin
  if spy=nil then exit;
  LNames := TStringList.Create;
  for i := 1 to RowCount - 1 do
  begin
    with Cell[i, 2] do
    begin
       if control is tiwcombobox then
        texto:=Tiwcombobox(Control).text
        else  texto :=TIWEdit(Control).Text
    end;
    Lnames.add(Cell[i, 0].Text+'='+texto);
  end;
  spy.ObjetoPostlista (lnames);
  FreeAndNil(LNames);
end;

function TIWPrimoProperties.RenderHTML: TIWHTMLTag;
begin
      if not Assigned (onrendercell) then
        onrendercell:=primoRenderCell;
      getPropiedades;
      renderHtml:=inherited renderhtml;
end;

procedure TIWPrimoProperties.primoRenderCell
        (ACell: TIWGridCell; const ARow, AColumn: Integer);
begin
  with ACell do begin
    if ARow = 0 then begin
      BGColor := clCream;
      Font.Style := [fsBold];
    end ;
  end;
end;

constructor TIWPrimoTreeObject.Create(AOwner: TComponent);
begin
   inherited create (aowner);
   fspy:=nil;
   PrimoProperties:=Nil;
end;

procedure TIWPrimoTreeObject.PrimoTreeObjectClick(Sender: TObject);
var na:string;
    o:tcomponent;
begin
  if sender is TIWTreeViewItem then
  if PrimoProperties<>nil then
  begin
    na:=(sender as TIWTreeViewItem).name;
    PrimoProperties.caption:=na;
    o:=tcomponent(Hextoint (copy(na,2,length(na)-1)));
    if o<>nil then
    begin
     spy.spynow:=o;
     if spy.escomponentedump (o) then
        PrimoProperties.caption:=na+'-'+o.ClassName;
    end;
  end;
end;


procedure TIWPrimoTreeObject.ScanComponents
        (  aComponent: Tobject; it:TIWTreeViewItems);
var
  I: Integer;
  co:Tcomponent;
  a:TIWTreeViewItem;
begin
  if (acomponent=nil) or (spy=nil) then exit;
  if (spy.listaya_<>nil) then
  begin
    if spy.listaya_.indexof (acomponent)>=0 then exit;
    spy.listaya_.Add (acomponent);
  end;
  a:=it.add;
  a.Caption:= acomponent.ClassName;
  a.OnClick:=PrimoTreeObjectClick;
  a.name:='o'+inttohex(integer(acomponent),8);
  if acomponent is tcomponent then
  begin
   co:=tcomponent (acomponent);
   if co.ComponentCount>0 then
   for I:= 0 to co.ComponentCount -1 do
    ScanComponents(co.Components[I],a.SubItems);
  end;
end;

function TIWPrimoTreeObject.RenderHTML: TIWHTMLTag;
begin
  if spy<>nil then
  begin
   spy.listaya_.Clear;
   items.Clear;
   ScanComponents(spy.spyobject,Items);
   spy.getsecuredirection;
  end;
  result:=inherited renderhtml;
end;


end.


